from leapp.libraries import stdlib
from leapp.libraries.stdlib import api
from leapp.models import InstalledTargetKernelVersion, DefaultBootKernelInfo


def process():
    boot_kernel = next(api.consume(DefaultBootKernelInfo), None)

    if boot_kernel.kernel_type == 'kernel':
        kernels = stdlib.run(["rpm", "-q", "kernel"], split=True)["stdout"]
        for kernel in kernels:
            version = kernel.split("-", 1)[1]
            if "el8" in version:
                api.produce(InstalledTargetKernelVersion(version=version))
                break
    else:
        kernels = stdlib.run(["rpm", "-q", "kernel-uek"], split=True)["stdout"]
        for kernel in kernels:
            version = kernel.split("-uek-", 1)[1]
            if "el8" in version:
                api.produce(InstalledTargetKernelVersion(version=version))
                break

